OpenTTD: src/openttd.h File Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- File List
- Globals

Typedefs | Enumerations | Functions | Variables
openttd.h File Reference

Some generic types. More...

`#include "core/enum_type.hpp"`

Go to the source code of this file.

## Typedefs
typedef SimpleTinyEnumT < PauseMode, byte > | PauseModeByte

## Enumerations
enum | GameMode { GM_MENU, GM_NORMAL, GM_EDITOR, GM_BOOTSTRAP }
| Mode which defines the state of the game. More...
enum | SwitchMode { SM_NONE, SM_NEWGAME, SM_RESTARTGAME, SM_EDITOR, SM_LOAD_GAME, SM_MENU, SM_SAVE_GAME, SM_SAVE_HEIGHTMAP, SM_GENRANDLAND, SM_LOAD_SCENARIO, SM_START_HEIGHTMAP, SM_LOAD_HEIGHTMAP }
| Mode which defines what mode we're switching to. More...
enum | DisplayOptions { DO_SHOW_TOWN_NAMES = 0, DO_SHOW_STATION_NAMES = 1, DO_SHOW_SIGNS = 2, DO_FULL_ANIMATION = 3, DO_FULL_DETAIL = 5, DO_SHOW_WAYPOINT_NAMES = 6, DO_SHOW_COMPETITOR_SIGNS = 7 }
| Display Options. More...
enum | PauseMode { PM_UNPAUSED = 0, PM_PAUSED_NORMAL = 1 << 0, PM_PAUSED_SAVELOAD = 1 << 1, PM_PAUSED_JOIN = 1 << 2, PM_PAUSED_ERROR = 1 << 3, PM_PAUSED_ACTIVE_CLIENTS = 1 << 4, PM_PAUSED_GAME_SCRIPT = 1 << 5, PMB_PAUSED_NETWORK = PM_PAUSED_ACTIVE_CLIENTS | PM_PAUSED_JOIN }
| Modes of pausing we've got. More...

## Functions
void | AskExitGame ()
void | AskExitToGameMenu ()
int | openttd_main (int argc, char *argv[])
| Main entry point for this lovely game.
void | HandleExitGameRequest ()
void | SwitchToMode (SwitchMode new_mode)

## Variables
GameMode | _game_mode
SwitchMode | _switch_mode
| The next mainloop command.
bool | _exit_game
PauseModeByte | _pause_mode
| The current pause mode.

## Detailed Description

Some generic types.

Definition in file openttd.h.

## Enumeration Type Documentation

enum DisplayOptions

Display Options.

Enumerator:

  DO_SHOW_TOWN_NAMES | Display town names.
  DO_SHOW_STATION_NAMES | Display station names.
  DO_SHOW_SIGNS | Display signs.
  DO_FULL_ANIMATION | Perform palette animation.
  DO_FULL_DETAIL | Also draw details of track and roads.
  DO_SHOW_WAYPOINT_NAMES | Display waypoint names.
  DO_SHOW_COMPETITOR_SIGNS | Display signs, station names and waypoint names of opponent companies. Buoys and oilrig-stations are always shown, even if this option is turned off.

Definition at line 42 of file openttd.h.

enum GameMode

Mode which defines the state of the game.

Definition at line 18 of file openttd.h.

enum PauseMode

Modes of pausing we've got.

Enumerator:

  PM_UNPAUSED | A normal unpaused game.
  PM_PAUSED_NORMAL | A game normally paused.
  PM_PAUSED_SAVELOAD | A game paused for saving/loading.
  PM_PAUSED_JOIN | A game paused for 'pause_on_join'.
  PM_PAUSED_ERROR | A game paused because a (critical) error.
  PM_PAUSED_ACTIVE_CLIENTS | A game paused for 'min_active_clients'.
  PM_PAUSED_GAME_SCRIPT | A game paused by a game script.
  PMB_PAUSED_NETWORK | Pause mode bits when paused for network reasons.

Definition at line 57 of file openttd.h.

enum SwitchMode

Mode which defines what mode we're switching to.

Enumerator:

  SM_NEWGAME | New Game –> 'Random game'.
  SM_RESTARTGAME | Restart –> 'Random game' with current settings.
  SM_EDITOR | Switch to scenario editor.
  SM_LOAD_GAME | Load game, Play Scenario.
  SM_MENU | Switch to game intro menu.
  SM_SAVE_GAME | Save game.
  SM_SAVE_HEIGHTMAP | Save heightmap.
  SM_GENRANDLAND | Generate random land within scenario editor.
  SM_LOAD_SCENARIO | Load scenario from scenario editor.
  SM_START_HEIGHTMAP | Load a heightmap and start a new game from it.
  SM_LOAD_HEIGHTMAP | Load heightmap from scenario editor.

Definition at line 26 of file openttd.h.

## Function Documentation

int openttd_main | ( | int | argc,
|  | char * | argv[]
| ) |  |

Main entry point for this lovely game.

Parameters

  argc | The number of arguments passed to this game.
  argv | The values of the arguments.

Returns
  0 when there is no error.

Definition at line 535 of file openttd.cpp.

References _blitter_autodetected, _config_file, _cur_resolution, _ini_blitter, _ini_musicdriver, _ini_sounddriver, _ini_videodriver, _load_check_data, _log_fd, _modal_progress_paint_mutex, _modal_progress_work_mutex, _network_available, _switch_mode, TarScanner::BASESET, ThreadMutex::BeginCritical(), BLT_8BPP, CheckForMissingGlyphs(), ClampU(), LoadCheckData::Clear(), DEBUG, AfterNewGRFScan::dedicated_host, AfterNewGRFScan::dedicated_port, DeterminePaths(), TarScanner::DoScan(), Driver::DT_MUSIC, Driver::DT_SOUND, Driver::DT_VIDEO, LoadCheckData::error, LoadCheckData::error_data, BaseMedia< GraphicsSet >::FindSets(), BaseMedia< SoundsSet >::FindSets(), BaseMedia< MusicSet >::FindSets(), FiosGetSavegameListCallback(), free(), GENERATE_NEW_SEED, GenerateWorld(), AfterNewGRFScan::generation_seed, VideoDriver::GetInstance(), GetOptData::GetOpt(), BaseMedia< GraphicsSet >::GetUsedSet(), GWM_EMPTY, HandleBootstrap(), LoadCheckData::HasErrors(), CursorVars::in_window, BaseMedia< SoundsSet >::ini_set, BaseMedia< MusicSet >::ini_set, BaseMedia< GraphicsSet >::ini_set, InitFreeType(), InitializeLanguagePacks(), InitializeScreenshotFormats(), InitializeSpriteSorter(), InitWindowSystem(), AfterNewGRFScan::join_company_password, AfterNewGRFScan::join_server_password, lastof, LoadFromConfig(), LoadIntroGame(), VideoDriver::MainLoop(), SmallFiosItem::mode, SmallFiosItem::name, AfterNewGRFScan::network_conn, NETWORK_DEFAULT_DEBUGLOG_PORT, NetworkStartUp(), GetOptData::numleft, GetOptData::opt, ParseConnectionString(), ParseResolution(), S8BPP_NONE, AfterNewGRFScan::save_config, SAVE_DIR, SaveHotkeysToConfig(), SaveOrLoad(), WindowDesc::SaveToConfig(), SaveToConfig(), SaveToHighScore(), ScanNewGRFFiles(), ScheduleErrorMessage(), BlitterFactory::SelectBlitter(), DriverFactoryBase::SelectDriver(), SetDebugString(), ErrorMessageData::SetDParamStr(), SetDParamStr(), BaseMedia< MusicSet >::SetSet(), BaseMedia< SoundsSet >::SetSet(), BaseMedia< GraphicsSet >::SetSet(), ShowHelp(), ShutdownGame(), SL_LOAD, SL_LOAD_CHECK, SL_OK, SLD_LOAD_GAME, SM_EDITOR, SM_LOAD_GAME, SM_LOAD_SCENARIO, SM_MENU, SM_NEWGAME, AfterNewGRFScan::startyear, strecpy(), stredup(), StrEmpty(), usererror(), WaitTillGeneratedWorld(), and ZOOM_LVL_NORMAL.